# 2. Python na platformach Unix

## 2.1. Pobieranie i instalacja najnowszej wersji Pythona

### 2.1.1. Na Linux

Python comes preinstalled on most Linux distributions, and is available as a package on all others. However there are certain features you might want to use that are not available on your distro’s package. You can easily compile the latest version of Python from source.

In the event that Python doesn’t come preinstalled and isn’t in the repositories as well, you can easily make packages for your own distro. Have a look at the following links:

Zobacz także

https://www.debian.org/doc/manuals/maint-guide/first.en.html

  dla użytkowników Debian

https://en.opensuse.org/Portal:Packaging

  dla użytkowników OpenSuse

https://docs.fedoraproject.org/en-US/package-maintainers/Packaging_Tutorial_GNU_Hello/

  dla użytkowników Fedora

https://slackbook.org/html/package-management-making-packages.html

  dla użytkowników Slackware

### 2.1.2. Na FreeBSD i OpenBSD

- Użytkownicy FreeBSD, aby dodać pakiet używają:

      pkg install python3

- OpenBSD users, to add the package use:

      pkg_add -r python

      pkg_add ftp://ftp.openbsd.org/pub/OpenBSD/4.2/packages/<insert your architecture here>/python-<version>.tgz

  For example i386 users get the 2.5.1 version of Python using:

      pkg_add ftp://ftp.openbsd.org/pub/OpenBSD/4.2/packages/i386/python-2.5.1p2.tgz

### 2.1.3. On OpenSolaris

You can get Python from OpenCSW. Various versions of Python are available and can be installed with e.g. `pkgutil -i python27`.

## 2.2. Building Python

If you want to compile CPython yourself, first thing you should do is get the source. You can download either the latest release’s source or just grab a fresh clone. (If you want to contribute patches, you will need a clone.)

The build process consists of the usual commands:

    ./configure
    make
    make install

Configuration options and caveats for specific Unix platforms are extensively documented in the README.rst file in the root of the Python source tree.

Ostrzeżenie

`make install` can overwrite or masquerade the `python3` binary. `make altinstall` is therefore recommended instead of `make install` since it only installs `exec_prefix/bin/pythonversion`.

## 2.3. Python-related paths and files

These are subject to difference depending on local installation conventions; `prefix` and `exec_prefix` are installation-dependent and should be interpreted as for GNU software; they may be the same.

For example, on most Linux systems, the default for both is `/usr`.

File/directory | Znaczenie
--- | ---
`exec_prefix/bin/python3` | Recommended location of the interpreter.
`prefix/lib/pythonversion`, `exec_prefix/lib/pythonversion` | Recommended locations of the directories containing the standard modules.
`prefix/include/pythonversion`, `exec_prefix/include/pythonversion` | Recommended locations of the directories containing the include files needed for developing Python extensions and embedding the interpreter.

## 2.4. Miscellaneous

To easily use Python scripts on Unix, you need to make them executable, e.g. with

    $ chmod +x script

and put an appropriate Shebang line at the top of the script. A good choice is usually

    #!/usr/bin/env python3

which searches for the Python interpreter in the whole `PATH`. However, some Unices may not have the env command, so you may need to hardcode `/usr/bin/python3` as the interpreter path.

To use shell commands in your Python scripts, look at the `subprocess` module.

## 2.5. Custom OpenSSL

1. To use your vendor’s OpenSSL configuration and system trust store, locate the directory with `openssl.cnf` file or symlink in `/etc`. On most distribution the file is either in `/etc/ssl` or `/etc/pki/tls`. The directory should also contain a `cert.pem` file and/or a `certs` directory.

       $ find /etc/ -name openssl.cnf -printf "%h\n"
       /etc/ssl

2. Download, build, and install OpenSSL. Make sure you use `install_sw` and not `install`. The `install_sw` target does not override `openssl.cnf`.

       $ curl -O https://www.openssl.org/source/openssl-VERSION.tar.gz
       $ tar xzf openssl-VERSION
       $ pushd openssl-VERSION
       $ ./config \
           --prefix=/usr/local/custom-openssl \
           --libdir=lib \
           --openssldir=/etc/ssl
       $ make -j1 depend
       $ make -j8
       $ make install_sw
       $ popd

3. Build Python with custom OpenSSL (see the configure `--with-openssl` and `--with-openssl-rpath` options)

       $ pushd python-3.x.x
       $ ./configure -C \
           --with-openssl=/usr/local/custom-openssl \
           --with-openssl-rpath=auto \
           --prefix=/usr/local/python-3.x.x
       $ make -j8
       $ make altinstall

Informacja

Patch releases of OpenSSL have a backwards compatible ABI. You don’t need to recompile Python to update OpenSSL. It’s sufficient to replace the custom OpenSSL installation with a newer version.